Index: main/channel.c
===================================================================
--- main/channel.c	(revision 342981)
+++ main/channel.c	(working copy)
@@ -4455,15 +4455,6 @@ int ast_indicate_data(struct ast_channel *chan, in
 		res = -1;
 	}
 
-	if (!res) {
-		/* The channel driver successfully handled this indication */
-		res = 0;
-		goto indicate_cleanup;
-	}
-
-	/* The channel driver does not support this indication, let's fake
-	 * it by doing our own tone generation if applicable. */
-
 	/*!\note If we compare the enumeration type, which does not have any
 	 * negative constants, the compiler may optimize this code away.
 	 * Therefore, we must perform an integer comparison here. */
@@ -4474,6 +4465,15 @@ int ast_indicate_data(struct ast_channel *chan, in
 		goto indicate_cleanup;
 	}
 
+	if (!res) {
+		/* The channel driver successfully handled this indication */
+		res = 0;
+		goto indicate_cleanup;
+	}
+
+	/* The channel driver does not support this indication, let's fake
+	 * it by doing our own tone generation if applicable. */
+
 	/* Handle conditions that we have tones for. */
 	switch (condition) {
 	case _XXX_AST_CONTROL_T38:
